
module('collisions', package.seeall)

-- fu can be function, null (key used) or name in collisionfns
-- '*' - collide with anything
-- notself - dont call on self collisions
collisionmap = {
	saucershot = {a='saucer', b='gunshot'},
	ballbounce = {a='ball', b='*', notself=true},
}

collisionfns = {
	saucershot = function(au,bu,coll) 
		cLevel.explosions:addExplosion(au.blk.b:getX(), au.blk.b:getY())
		playsound(sounds.exp1)
	end,
	ballbounce = function()
		playsound(sounds.hit1)
  	end,
}