
local socket = require("socket")
--local mime = require 'mime'				-- websock
--local coxpcall = require 'coxpcall'		-- websock
--local copas = require 'copas'			-- websock

local http = require("socket.http")
local ltn12 = require("ltn12")

--local websocket = require 'websocket' 	-- websock


local assert = assert
local print = print
local tostring = tostring
local tconcat = table.concat
local strformat = string.format
local strmatch = string.match
local strlower = string.lower
local setmetatable = setmetatable
local getmetatable = getmetatable


module ('socktest', package.seeall)


function nodeTcpTest()
	local sock = assert(socket.connect("localhost",  2500))
	local ip, port = sock:getsockname()
	print("node IP Address: " .. ip)
	print("node Port: " .. port)
	sock:send('from lua')
	--local s = sock:receive()
	--print(s)
end

function webSocketAtempt()
	-- local host = '*' 
	-- local port = 0 
	local host = "localhost"
	--local port = 8080
	local port = 80
	local sock = socket.tcp()
	--websocket.wrap(sock)
	--local c = assert(socket.connect(host, port)
	assert(sock:bind(host, port))
	skt = copas.wrap(sock)
	local wsock = websocket.wrap(skt)
	--assert(socket.bind(sock, host, port))
	-- http://pastebin.com/f50d79dcd
	-- copas.wrap(socket)
	-- websocket.wrap(socket)
	-- copas.addserver(server, handle)
	local ip, port = sock:getsockname()
	print("IP Address: " .. ip)
	print("Port: " .. port)
	-- copas.addserver(wsock, echoHandler)
	-- copas.loop()
	--receiveUTF8(webskt)
	-- function sendUTF8(webskt, msg)
	-- receiveBase64(...)
	-- function sendBase64(webskt, binstring)
	--websocket.sendUTF8(wsock, "hello there?")
	wsock:sendUTF8("hello there?")
end

function sockGoogle()
	--Connect to the client
	local goosoc = socket.connect("www.google.com",  80)
	--Get IP and Port from client
	ip, port = goosoc:getsockname()
	--Print the ip address and port to the terminal
	print("google IP Address: " .. ip)
	print("google Port: " .. port)
end

function saveRemoteImage()
	local myFile = io.open( 'test.png', "w+b" ) 
	http.request{
	    url = "http://developer.anscamobile.com/demo/hello.png", 
	    sink = ltn12.sink.file(myFile),
	}
	-- Display local file
	--testImage = display.newImage("hello.png",system.DocumentsDirectory,60,50)	
end

function dumpRemoteHtml()
	-- connect to server "www.cs.princeton.edu" and retrieves this manual
	-- file from "~diego/professional/luasocket/http.html" and print it to stdout
	http.request{ 
	    url = "http://www.cs.princeton.edu/~diego/professional/luasocket/http.html", 
	    sink = ltn12.sink.file(io.stdout)
	}
end
