module('utils', package.seeall)


function callCoros(t, onError, ...)
	for k, co in pairs(t) do
		if coroutine.status(co) == 'dead' then
			t[k] = nil
		else 
			local status,err = coroutine.resume(co, ...)
			if status == false then
				local stacktrace = debug.traceback(co)
				onError(err, stacktrace, k, ...)
			end				
		end
	end
end

--[[
function callCoroutine(co, ...)
	local status,err = coroutine.resume(co, ...)
	if status == false then
		local stacktrace = debug.traceback(co)
		error('coroutine error.\n rig: '..r.name..' key: '..k
			..'\n err: '..err..'\n '..stacktrace)
	end
end
--]]