

module('draw', package.seeall)



drawMethods = {}

drawMethods.staticRect = function(blk)
	love.graphics.drawq(blk.imgDef.image, blk.imgDef.quad, blk.b:getX()+blk.x, blk.b:getY()+blk.y, blk.b:getAngle(), 1, 1, blk.imgDef.ox, blk.imgDef.oy)
	--love.graphics.polygon("line", blk.s:getPoints())
end

drawMethods.dynamicRect = function(blk)
	if blk.imgDef.quad then
		love.graphics.drawq(blk.imgDef.image, blk.imgDef.quad, blk.b:getX(), blk.b:getY(), blk.b:getAngle(), 1, 1, blk.imgDef.ox, blk.imgDef.oy)
	else
		love.graphics.draw(blk.imgDef.image, blk.b:getX(), blk.b:getY(), blk.b:getAngle(), 1, 1, blk.imgDef.ox, blk.imgDef.oy)
	end

	if false then --blk.lvl.showPhyShapes then
		love.graphics.polygon("line", blk.b:getWorldPoints(blk.s:getPoints()))
	end
end

drawMethods.dynamicCircle = function(blk)
	love.graphics.draw(blk.imgDef.image, blk.b:getX(), blk.b:getY(), blk.b:getAngle(), 1, 1, blk.imgDef.ox, blk.imgDef.oy)
	if false then --if blk.lvl.showPhyShapes then
		love.graphics.circle("line", blk.b:getX(), blk.b:getY(), blk.imgDef.r) 
	end	
end

drawMethods.plainImage = function(blk)
	love.graphics.draw(blk.imgDef.image, blk.x, blk.y, 0, 1, 1, blk.imgDef.ox, blk.imgDef.oy)
end
